
code = {}
		-- Parent Functions
		function code.p_load()																								-- love.load parent function
			img.load()
			snd.load()
			opt.load()
			player.load()
			gui.load()
		end
		function code.p_update(dt)																				-- love.update parent function
			if gui.state == 0 then gui.time = gui.time + dt end
			km.update()
		end
		function code.p_draw()																							-- love.draw parent function	

			if gui.state == 0 then 	-- Loading
				gui.into()
			elseif gui.state  == 1 then -- Menu
				gui.menu()		
			elseif gui.state  == 2 then -- Paused
				gui.pause()
			elseif gui.state  == 3 then -- Playing
				gui.play()
			elseif gui.state  == 4 then  -- End
				gui.over()
			elseif gui.state  == 5 then -- Information
				gui.info()
			elseif gui.state  == 6 then -- Settings
				gui.settings()
			end
			opt.draw()
		end

		
		
gui = {} -- Display and Interface Items
		
		function gui.load()
			gui.state = 0
			gui.time = 0
			gui.font = love.graphics.newFont('FILES/MISC/oswald.ttf', 10)								-- Print function font
			love.graphics.setFont(gui.font)
			gui.version = '0.012315'	
			gui.menu_scale = 5
			gui.menu_H = 0
		end	
		
		
		--STATES
		function gui.into()																										-- [0] Initial loading screen 
			love.graphics.setColor(255, 255, 255, 255)
			if gui.time <4 and gui.time >2 then love.audio.play(snd.intro) else end
			if gui.time <4 and gui.time >2 then love.graphics.draw(img.lua, (opt.res_X / 2) - (img.lua:getWidth() / 2), (opt.res_Y / 2) - (img.lua:getHeight() / 2)) else end		
			if gui.time <6 and gui.time >4 then love.graphics.draw(img.love, (opt.res_X / 2) - (img.love:getWidth() / 2), (opt.res_Y / 2) - (img.love:getHeight() / 2)) else end
			if gui.time <8 and gui.time  >6 then love.graphics.draw(img.openal, (opt.res_X / 2) - (img.openal:getWidth() / 2), (opt.res_Y / 2) - (img.openal:getHeight() / 2)) else end
			if gui.time <10 and gui.time >8 then love.graphics.draw(img.opengl, (opt.res_X / 2) - (img.opengl:getWidth() / 2), (opt.res_Y / 2) - (img.opengl:getHeight() / 2)) else end
			if gui.time <14 and gui.time >10 then love.graphics.draw(img.odns, (opt.res_X / 2) - (img.odns:getWidth() / 2), (opt.res_Y / 2) - (img.odns:getHeight() / 2)) else end
			if gui.time >14 then gui.state = 1 else end
			if gui.time >14 then gui.time = 0 else end
		end
		
		function gui.menu() 																							-- [1] Beginning menu screen
			gui.menu_H = 0
			gui.menu_scale = 5
			love.graphics.setColor(255, 255, 255, 255)
			love.graphics.draw(img.love_bg, (opt.res_X / 2) - (img.love_bg:getWidth() / 2), (opt.res_Y / 2) - (img.love_bg:getHeight() / 2))
			love.graphics.draw(img.space_escape, (opt.res_X / 2) - (img.space_escape:getWidth() / 2), (opt.res_Y / 3) - (img.space_escape:getHeight() / 2))
				button.exit() 
				button.settings() 
				button.play() 
		end

		function gui.pause() end																							-- [2] Paused or out of focus screen 
		function gui.play() 																							-- [3] Game in progress and in focus 
			love.graphics.setColor(255, 255, 255, 255)
			love.graphics.draw(img.starfield, (opt.res_X / 2) - (img.starfield:getWidth() / 2) + player.direction_X, (opt.res_Y / 2) - (img.starfield:getHeight() / 2) + player.direction_Y)		
			love.graphics.draw(img.player, (opt.res_X/2) - (img.player:getWidth() / 2), (opt.res_Y/2) - (img.player:getHeight() / 2))

		end
		
		
		function gui.settings() end																						-- [4] Settings and Options Menu
		function gui.tab() end																								-- [8] Display inventory and player stats 		[ TAB ] to enable/disable 
		function gui.exit() end																								-- [9] Exit screen to quit program				[ ESC ] to quit out		

button = {}

		function button.play() 
						--button play
			img.button_play_W = img.button_play:getWidth()
			img.button_play_H = img.button_play:getHeight()
			img.button_play_X = (opt.res_X - (img.button_play_W + gui.menu_scale))
			img.button_play_Y = (opt.res_Y - (img.button_play_H + gui.menu_scale + gui.menu_H)) 
			love.graphics.draw(img.button_play, img.button_play_X, img.button_play_Y)
			gui.menu_scale = gui.menu_scale + 5
			gui.menu_H = (gui.menu_H + img.button_play_H) 				
				-- if mouse over button
				if  km.mX >= img.button_play_X and km.mX <= (img.button_play_X + img.button_play_W) and km.mY >= img.button_play_Y and km.mY <= (img.button_play_Y + img.button_play_H) then
				love.graphics.setColor(255, 255, 0, 255)
				love.graphics.draw(img.button_play, img.button_play_X, img.button_play_Y)
				love.graphics.setColor(255, 255, 255, 255)
					if love.mouse.isDown('l') then 
						love.audio.play(snd.select)  
						gui.state = 3
					end
				end
		end	
		function button.settings() 
					--button settingss
			img.button_settings_W = img.button_settings:getWidth()
			img.button_settings_H = img.button_settings:getHeight()
			img.button_settings_X = (opt.res_X - (img.button_settings_W + gui.menu_scale))
			img.button_settings_Y = (opt.res_Y - (img.button_settings_H + gui.menu_scale + gui.menu_H)) 
			love.graphics.draw(img.button_settings, img.button_settings_X, img.button_settings_Y)
			gui.menu_scale = gui.menu_scale + 5
			gui.menu_H = (gui.menu_H + img.button_settings_H) 				
				-- if mouse over button
				if  km.mX >= img.button_settings_X and km.mX <= (img.button_settings_X + img.button_settings_W) and km.mY >= img.button_settings_Y and km.mY <= (img.button_settings_Y + img.button_settings_H) then
				love.graphics.setColor(255, 255, 0, 255)
				love.graphics.draw(img.button_settings, img.button_settings_X, img.button_settings_Y)
				love.graphics.setColor(255, 255, 255, 255)
					if love.mouse.isDown('l') then 
						love.audio.play(snd.select) 
						gui.state = 6
					end
				end
		end	
		function button.exit() 
					--button exit
			img.button_exit_W = img.button_exit:getWidth()
			img.button_exit_H = img.button_exit:getHeight()
			img.button_exit_X = (opt.res_X - (img.button_exit_W + gui.menu_scale))
			img.button_exit_Y = (opt.res_Y - (img.button_exit_H + gui.menu_scale + gui.menu_H))
			love.graphics.draw(img.button_exit, img.button_exit_X, img.button_exit_Y)
			gui.menu_H = (gui.menu_H + img.button_exit_H)
			gui.menu_scale = gui.menu_scale + 5				
				-- if mouse over button
				if  km.mX >= img.button_exit_X and km.mX <= (img.button_exit_X + img.button_exit_W) and km.mY >= img.button_exit_Y and km.mY <= (img.button_exit_Y + img.button_exit_H) then
				love.graphics.setColor(255, 255, 0, 255)
				love.graphics.draw(img.button_exit, img.button_exit_X, img.button_exit_Y)
				love.graphics.setColor(255, 255, 255, 255)
				if love.mouse.isDown('l') then love.audio.play(snd.select) end
				if love.mouse.isDown('l') then love.event.quit() end
				end
		end	
		function button.enable() end	
		function button.disable() end	
		function button.placer() end	
		function button.score() end	
		function button.yes() end	
		function button.no() end	
		function button.menu() end	
		function button.create() end	


opt = {} -- Options and Settings
	
	function opt.load()
		opt.console_key = -1
		opt.console = 0																							-- Enable/Disable Console							[ - ] to enable/disable																				
		opt.wireframe = 1																						-- Enable/Disable Wireframe						[ * ] to enable/disable
		opt.music = 1																							-- Enable/Disable Background Music			[ / ] to enable/disable	
		opt.windowmode = 0																					-- Enable/Disable Windowed Mode				[ + ] to enable/disable	
		opt.res_Y = love.graphics.getHeight()															-- Resolution x Size																						
		opt.res_X = love.graphics.getWidth()															-- Resolution y Size
		opt.detail = 1																								-- Texture Detail
		opt.volume = 1																							-- Master Volume
		opt.difficulty = 1																						-- Difficulty level
		opt.name = 'odnsrvn'																					-- Player Name
		opt.fpsmax = 99																						-- Maximum FPS
		opt.fpsshow = 1																							-- Show FPS on screen
	end
	
	function opt.draw()


			if opt.console >= 1 then
				love.graphics.setColor(255, 255, 255, 255)
				--TOP_LEFT SIDE
				opt.scale = 5
				love.graphics.print("TIME: " .. gui.time, 10, (opt.scale))
				opt.scale = opt.scale + 15
				love.graphics.print("STATE: " .. gui.state, 10, (opt.scale))				
				opt.scale = opt.scale + 15
				love.graphics.print("RES: " .. opt.res_X .. ' x '.. opt.res_Y, 10, (opt.scale))
				opt.scale = opt.scale + 15
				love.graphics.print("VERSION: " .. gui.version, 10, (opt.scale))
				opt.scale = opt.scale + 15
				love.graphics.print("MOUSE: " .. 'X:' ..km.mX .. ' '.. 'Y:' .. km.mY , 10, (opt.scale))
				opt.scale = opt.scale + 15
				love.graphics.print("PLAYER: " .. 'X:' ..player.X .. ' '.. 'Y:' .. player.Y , 10, (opt.scale))
				opt.scale = opt.scale + 15
				love.graphics.print("CONSOLE: " .. opt.console .. ' STATE', 10, (opt.scale))
				
				if opt.fpsshow == 1 then
				love.graphics.setColor(0, 255, 0, 150)
				love.graphics.print("FPS: "..tostring(love.timer.getFPS( )), opt.res_X - 55, 5)
				love.graphics.setColor(255, 255, 0, 150)
				love.graphics.print('GARBAGE: ' .. collectgarbage("count")/1024, 10, opt.res_Y - 15)
				end
				
			end
		
	end


	
km = {}  -- Keyboard and Mouse 
		function km.update()
			km.mX = love.mouse.getX()																				-- Mouse X position on screen
			km.mY = love.mouse.getY()																					-- Mouse Y position on screen
			
			if love.keyboard.isDown('w') then 
				player.Y = player.Y - player.speed 
				player.direction_Y = (player.direction_Y + (player.speed/2))
			end
			
			if love.keyboard.isDown('s') then 
				player.Y = player.Y + player.speed 
				player.direction_Y = (player.direction_Y - (player.speed/2))
			end
			
			if love.keyboard.isDown('a') then 
				player.X = player.X - player.speed  
				player.direction_X = (player.direction_X + (player.speed/2))
			end
			
			if love.keyboard.isDown('d') then 
				player.X = player.X + player.speed 
				player.direction_X = (player.direction_X - (player.speed/2))
			end
			

		
				if love.keyboard.isDown("escape") and gui.state >= 0 then gui.state = 1 end
			
			if opt.console == 0 then
				if love.keyboard.isDown("[")  then 
				opt.console = 1
				else end
			end
			if opt.console ==1 then
					if love.keyboard.isDown("]") then 
					opt.console = 0
					end
			end
		end
		
		function km.console() end																						-- [ - ] Console Function key press
		function km.wireframe() end																					-- [ * ] Wireframe function key press 
		function km.music() end																							-- [ / ] Music function when key press
		function km.windowmode() end																				-- [ + ] Windowed Mode function when key press
		function km.wasd() end																							-- [W] [A] [S] [D] Movement functions when keys are pressed


player = {} -- Player and Statistics 
		
		function player.load()
			player.state = 0																				-- [0] Dead [1] Alive
			player.name = opt.name																-- Player Name
			player.hp = 100																				-- Player health
			player.armor = 100																		-- Player armor			
			player.speed = 3																				-- Player speed
			player.w = 10																				-- Player width
			player.h = 20																					-- Player height
			player.direction_X = 0
			player.direction_Y = 0
			--player.img																						-- Player texture 
			player.X = opt.res_X/2																	-- Player start x
			player.Y = opt.res_Y/2																	-- Player start y 
		end

img = {} -- Images and Textures
	function img.load()
		img.lua = love.graphics.newImage('FILES/IMG/lua.png')
		img.opengl = love.graphics.newImage('FILES/IMG/opengl.png')
		img.openal = love.graphics.newImage('FILES/IMG/openal.png')
		img.love = love.graphics.newImage('FILES/IMG/love.png')
		img.odns = love.graphics.newImage('FILES/IMG/odnsrvns.png')
		img.player = love.graphics.newImage('FILES/IMG/spaceship.png')
		img.background = love.graphics.newImage('FILES/IMG/space.jpg')
		img.grass = love.graphics.newImage('FILES/IMG/grass.jpg')
		img.button_play = love.graphics.newImage('FILES/IMG/play.png')
		img.button_settings = love.graphics.newImage('FILES/IMG/settings.png')
		img.button_exit = love.graphics.newImage('FILES/IMG/exit.png')
		img.button_placer = love.graphics.newImage('FILES/IMG/placer.png')
		img.button_on = love.graphics.newImage('FILES/IMG/on.png')
		img.button_off = love.graphics.newImage('FILES/IMG/off.png')
		img.button_yes = love.graphics.newImage('FILES/IMG/yes.png')
		img.button_no = love.graphics.newImage('FILES/IMG/no.png')
		img.love_bg = love.graphics.newImage('FILES/IMG/space.jpg')
		img.space_escape = love.graphics.newImage('FILES/IMG/space_escape.png')
		img.starfield = love.graphics.newImage('FILES/IMG/starfield.png')

	end
	
snd = {} -- Sounds and Audio
	function snd.load()
		snd.intro = love.audio.newSource("FILES/SND/intro.wav")
		snd.select = love.audio.newSource('FILES/SND/select.wav')
		snd.pitch = 1
		snd.volume = opt.volume
	end







